<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CapabilityAgents/AudioPlayer/include/AudioPlayer/StreamFormat.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_9dde9d78e15cabfb8e2b222ee9474f52.html">AudioPlayer</a></li><li class="navelem"><a class="el" href="dir_0b9723c2c8bc9e838121a6fbc73cf49e.html">include</a></li><li class="navelem"><a class="el" href="dir_96850cc6d2c5822d23f38a41ba6afa08.html">AudioPlayer</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">StreamFormat.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_stream_format_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CAPABILITYAGENTS_AUDIOPLAYER_INCLUDE_AUDIOPLAYER_STREAMFORMAT_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CAPABILITYAGENTS_AUDIOPLAYER_INCLUDE_AUDIOPLAYER_STREAMFORMAT_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;ostream&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_dialog_u_x_state_observer_interface_8h.html">AVSCommon/SDKInterfaces/DialogUXStateObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_j_s_o_n_utils_8h.html">AVSCommon/Utils/JSON/JSONUtils.h</a>&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">namespace </span>capabilityAgents {</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span>audioPlayer {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">   29</a></span>&#160;<span class="keyword">enum class</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">StreamFormat</a> {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1ae5d311084477fc09c9f898f444f47e53">AUDIO_MPEG</a>,</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1a696b031073e74bf2cb98e5ef201d4aa3">UNKNOWN</a></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;};</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a16232f6c709581720898ad7ad1fae21e">   42</a></span>&#160;<span class="keyword">inline</span> std::string <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a16232f6c709581720898ad7ad1fae21e">streamFormatToString</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">StreamFormat</a> streamFormat) {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordflow">switch</span> (streamFormat) {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1ae5d311084477fc09c9f898f444f47e53">StreamFormat::AUDIO_MPEG</a>:</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;AUDIO_MPEG&quot;</span>;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1a696b031073e74bf2cb98e5ef201d4aa3">StreamFormat::UNKNOWN</a>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    }</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordflow">return</span> <span class="stringliteral">&quot;unknown StreamFormat&quot;</span>;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#adc9cbd7a93a36f3db5500ae81e8a72d9">   59</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#adc9cbd7a93a36f3db5500ae81e8a72d9">stringToStreamFormat</a>(<span class="keyword">const</span> std::string&amp; text, <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">StreamFormat</a>* streamFormat) {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordflow">if</span> (<span class="keyword">nullptr</span> == streamFormat) {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (text == <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a16232f6c709581720898ad7ad1fae21e">streamFormatToString</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1ae5d311084477fc09c9f898f444f47e53">StreamFormat::AUDIO_MPEG</a>)) {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        *streamFormat = <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1ae5d311084477fc09c9f898f444f47e53">StreamFormat::AUDIO_MPEG</a>;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;}</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#ae64ed9c3e1a0e461473e9d6eb82c72b0">   76</a></span>&#160;<span class="keyword">inline</span> std::ostream&amp; <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a6595949db3e4db1d3512dc3372d26036">operator&lt;&lt;</a>(std::ostream&amp; stream, <span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">StreamFormat</a>&amp; streamFormat) {</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordflow">return</span> stream &lt;&lt; <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a16232f6c709581720898ad7ad1fae21e">streamFormatToString</a>(streamFormat);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;}</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a0b0fbce0c7e276d9ce0a5fb547938163">   87</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a4d5e17b1f13073c9c66f3bd12cfcdc90">convertToValue</a>(<span class="keyword">const</span> rapidjson::Value&amp; documentNode, <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">StreamFormat</a>* streamFormat) {</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    std::string text;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#aa97f53eadfa124bb8797e1325b4dbe52">avsCommon::utils::json::jsonUtils::convertToValue</a>(documentNode, &amp;text)) {</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    }</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#adc9cbd7a93a36f3db5500ae81e8a72d9">stringToStreamFormat</a>(text, streamFormat);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;}</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;}  <span class="comment">// namespace audioPlayer</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;}  <span class="comment">// namespace capabilityAgents</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CAPABILITYAGENTS_AUDIOPLAYER_INCLUDE_AUDIOPLAYER_STREAMFORMAT_H_</span></div><div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_a4d5e17b1f13073c9c66f3bd12cfcdc90"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a4d5e17b1f13073c9c66f3bd12cfcdc90">alexaClientSDK::capabilityAgents::audioPlayer::convertToValue</a></div><div class="ttdeci">bool convertToValue(const rapidjson::Value &amp;documentNode, ClearBehavior *clearBehavior)</div><div class="ttdef"><b>Definition:</b> ClearBehavior.h:91</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_adc9cbd7a93a36f3db5500ae81e8a72d9"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#adc9cbd7a93a36f3db5500ae81e8a72d9">alexaClientSDK::capabilityAgents::audioPlayer::stringToStreamFormat</a></div><div class="ttdeci">bool stringToStreamFormat(const std::string &amp;text, StreamFormat *streamFormat)</div><div class="ttdef"><b>Definition:</b> StreamFormat.h:59</div></div>
<div class="ttc" id="_j_s_o_n_utils_8h_html"><div class="ttname"><a href="_j_s_o_n_utils_8h.html">JSONUtils.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_a3a72a48a942acbcb33ead93b1bf86fb1"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1">alexaClientSDK::capabilityAgents::audioPlayer::StreamFormat</a></div><div class="ttdeci">StreamFormat</div><div class="ttdoc">Specifies the format of a binary audio attachment in a Play directive. </div><div class="ttdef"><b>Definition:</b> StreamFormat.h:29</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_a3a72a48a942acbcb33ead93b1bf86fb1a696b031073e74bf2cb98e5ef201d4aa3"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1a696b031073e74bf2cb98e5ef201d4aa3">alexaClientSDK::capabilityAgents::audioPlayer::StreamFormat::UNKNOWN</a></div><div class="ttdoc">Audio is an unknown/unsupported format. </div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_a6595949db3e4db1d3512dc3372d26036"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a6595949db3e4db1d3512dc3372d26036">alexaClientSDK::capabilityAgents::audioPlayer::operator&lt;&lt;</a></div><div class="ttdeci">std::ostream &amp; operator&lt;&lt;(std::ostream &amp;stream, const ClearBehavior &amp;clearBehavior)</div><div class="ttdef"><b>Definition:</b> ClearBehavior.h:80</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils_html_aa97f53eadfa124bb8797e1325b4dbe52"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#aa97f53eadfa124bb8797e1325b4dbe52">alexaClientSDK::avsCommon::utils::json::jsonUtils::convertToValue</a></div><div class="ttdeci">bool convertToValue(const rapidjson::Value &amp;documentNode, std::string *value)</div><div class="ttdef"><b>Definition:</b> JSONUtils.cpp:146</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_a3a72a48a942acbcb33ead93b1bf86fb1ae5d311084477fc09c9f898f444f47e53"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a3a72a48a942acbcb33ead93b1bf86fb1ae5d311084477fc09c9f898f444f47e53">alexaClientSDK::capabilityAgents::audioPlayer::StreamFormat::AUDIO_MPEG</a></div><div class="ttdoc">Audio is in mpeg format. </div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player_html_a16232f6c709581720898ad7ad1fae21e"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1capability_agents_1_1audio_player.html#a16232f6c709581720898ad7ad1fae21e">alexaClientSDK::capabilityAgents::audioPlayer::streamFormatToString</a></div><div class="ttdeci">std::string streamFormatToString(StreamFormat streamFormat)</div><div class="ttdef"><b>Definition:</b> StreamFormat.h:42</div></div>
<div class="ttc" id="_dialog_u_x_state_observer_interface_8h_html"><div class="ttname"><a href="_dialog_u_x_state_observer_interface_8h.html">DialogUXStateObserverInterface.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
